From 1a68cff66a328ce7826b4b9143707aee9ad97ce9 Mon Sep 17 00:00:00 2001
From: Wang Ziming <wangziming@huawei.com>
Date: Thu, 2 Apr 2020 20:48:24 +0800
Subject: [PATCH 33/77] virsh_blockcopy: change disk_target_bus and disk_format
 for lun_t type disk_device

As virtio lun does not work currently, when the disk type is lun, the
disk_target_bus should be scsi, otherwise it will be error: "Please
set scsi=off for virtio-blk devices". And the disk_format should be raw,
qcow2 will be error: disk device 'lun' using target 'scsi' must use 'raw' format.

Signed-off-by: Wang Ziming <wangziming@huawei.com>
---
 .../cfg/virsh_cmd/domain/virsh_blockcopy.cfg      | 15 +++++++++------
 .../tests/src/virsh_cmd/domain/virsh_blockcopy.py |  3 +++
 2 files changed, 12 insertions(+), 6 deletions(-)

diff --git a/libvirt/tests/cfg/virsh_cmd/domain/virsh_blockcopy.cfg b/libvirt/tests/cfg/virsh_cmd/domain/virsh_blockcopy.cfg
index 581d3f69..fe547441 100644
--- a/libvirt/tests/cfg/virsh_cmd/domain/virsh_blockcopy.cfg
+++ b/libvirt/tests/cfg/virsh_cmd/domain/virsh_blockcopy.cfg
@@ -94,9 +94,6 @@
                 - block_disk:
                     replace_vm_disk = "yes"
                     disk_source_protocol = "iscsi"
-                    disk_target = "vda"
-                    disk_target_bus = "virtio"
-                    disk_format = "qcow2"
                     image_size = "10G"
                     emulated_image = "emulated-iscsi"
                     variants:
@@ -113,8 +110,14 @@
                         - lun_t:
                             no volume_type, no_blockdev, shallow
                             disk_device = 'lun'
+                            disk_target = "sda"
+                            disk_target_bus = "scsi"
+                            disk_format = "raw"
                         - disk_t:
                             disk_device = 'disk'
+                            disk_target = "vda"
+                            disk_target_bus = "virtio"
+                            disk_format = "qcow2"
             variants:
                 - non_acl:
                 - acl_test:
@@ -166,9 +169,9 @@
                     replace_vm_disk = "yes"
                     disk_source_protocol = "iscsi"
                     disk_device = 'lun'
-                    disk_target = "vda"
-                    disk_target_bus = "virtio"
-                    disk_format = "qcow2"
+                    disk_target = "sda"
+                    disk_target_bus = "scsi"
+                    disk_format = "raw"
                     image_size = "10G"
                     emulated_image = "emulated-iscsi"
                     variants:
diff --git a/libvirt/tests/src/virsh_cmd/domain/virsh_blockcopy.py b/libvirt/tests/src/virsh_cmd/domain/virsh_blockcopy.py
index 456dec03..9a511ff9 100644
--- a/libvirt/tests/src/virsh_cmd/domain/virsh_blockcopy.py
+++ b/libvirt/tests/src/virsh_cmd/domain/virsh_blockcopy.py
@@ -235,6 +235,7 @@ def run(test, params, env):
 
     vm_name = params.get("main_vm")
     vm = env.get_vm(vm_name)
+    disk_target = params.get("disk_target", "")
     target = params.get("target_disk", "")
     replace_vm_disk = "yes" == params.get("replace_vm_disk", "no")
     disk_source_protocol = params.get("disk_source_protocol")
@@ -502,6 +503,8 @@ def run(test, params, env):
                 nfs_cleanup = True
             utl.set_vm_disk(vm, params, tmp_dir, test)
             new_xml = vm_xml.VMXML.new_from_inactive_dumpxml(vm_name)
+            if disk_target != "":
+                target = disk_target
 
         if with_shallow:
             _make_snapshot()
-- 
2.23.0

